/*
 * Copyright (c) 2006, Your Corporation. All Rights Reserved.
 */

package org.jdesktop.jdic.screensaver.bouncingline;

import gui.run.RunButton;
import org.jdesktop.jdic.screensaver.ScreensaverContext;
import org.jdesktop.jdic.screensaver.ScreensaverFrame;
import org.jdesktop.jdic.screensaver.SimpleScreensaver;

import javax.swing.*;
import java.awt.*;


public class Test2
        extends SimpleScreensaver {
    private JPanel buttonControlPanel = getButtonControlPanel();

    private JPanel getButtonControlPanel() {
        JPanel jp = new JPanel();
        jp.setLayout(new FlowLayout());
        jp.add(new RunButton("ok") {
            public void run() {
                System.out.println(getText());
            }
        });
        jp.add(new RunButton("cancel") {
            public void run() {
                System.out.println(getText());
            }
        });
        return jp;
    }

    public void init() {
        ScreensaverContext c = super.getContext();
        Component comp = c.getComponent();
        if (comp instanceof JFrame) {
            JFrame jf = (JFrame) comp;
            jf.getContentPane().add(buttonControlPanel);
            return;
        }
        if (comp instanceof JPanel) {
            JPanel jp = (JPanel) comp;
            jp.add(buttonControlPanel);
            return;
        }
        System.out.println("could not identify:" + comp.getClass().getName());

    }

    public void paint(Graphics g) {
        Component c = getContext().getComponent();
        c.paint(g);
    }


    public static void main(String[] args) {
        new ScreensaverFrame(new Test2()).setVisible(true);
    }
}
