package video.broadcast;

import gui.ClosableJFrame;

import java.awt.image.BufferedImage;
import java.awt.*;
import java.io.File;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.MalformedURLException;

import futils.Futil;

import javax.imageio.ImageIO;

import j2d.ImageUtils;
import video.CameraUtils;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Mar 30, 2006
 * Time: 6:22:24 PM
 */
public  class ImageFrame extends ClosableJFrame {
    private BufferedImage img = null;

    public static void main(String[] args)  {
        try {
            ImageFrame IF = new ImageFrame();
            IF.setImage(ImageUtils.getBufferedImage(CameraUtils.getWebCamImage()));
            IF.setVisible(true);
            for (int i=0; i < 1000; i++){
               IF.setImage(ImageUtils.getBufferedImage(CameraUtils.getWebCamImage()));
                Thread.sleep(1000);
               System.out.println(i);
            }
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
    public void getImage() {
        try {
            File f = Futil.getReadFile("select an image file");
            getImage(f);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void getImage(File f) throws IOException {
        FileInputStream fis = new FileInputStream(f);
        getImage(fis);
    }

    public void getImage(InputStream is) throws IOException {
        BufferedImage bi = ImageIO.read(is);
        is.close();
        setImage(bi);
    }

    public void setImage(BufferedImage bi) {
        img = bi;
        setSize(bi.getWidth(), bi.getHeight());
        repaint();
    }

    public void paint(Graphics g) {
        if (img == null) {
            g.drawString("no data rcvd", 0, this.getHeight() / 2);
            return;
        }
        Graphics2D g2d = (Graphics2D) g;
        g2d.drawImage(img, null, 0, 0);
    }
}
